#include <stdlib.h>

#include "mpg123.h"

int synth_1to1_mono(real *bandPtr,unsigned char *samples,int *pnt)
{
  short samples_tmp[64];
  short *tmp1 = samples_tmp;
  int i,ret;
  int pnt1 = 0;

  ret = synth_1to1_486(bandPtr,0,(unsigned char *) samples_tmp,&pnt1);
  samples += *pnt;

  for(i=0;i<32;i++) {
    *( (short *) samples) = *tmp1;
    samples += 2;
    tmp1 += 2;
  }
  *pnt += 64;

  return ret;
}


int synth_1to1_486(real *bandPtr,int channel,unsigned char *out,int nb_blocks)
{
  static int buffs[2][2][17*FIR_BUFFER_SIZE];
  static int bo[2] = { 16 -1, 16 -1 };
  short *samples = (short *) out;
  int *b0,(*buf)[17*FIR_BUFFER_SIZE];
  int clip = 0;
  int block,b,bo_start;


  samples+=channel;

  bo_start=bo[channel];
  buf = buffs[channel];

  b=bo_start;
  for(block=0;block<nb_blocks;block++) {


    b++;
    if (b >= FIR_BUFFER_SIZE) {
      int *p,*q;
      int c,i,j;


      for(c=0;c<2;c++) {
        p=&buf[c][0]+1;
        q=p+(FIR_BUFFER_SIZE-16);
        for(i=0;i<17;i++) {
          for(j=0;j<16 -1;j++) p[j]=q[j];
          p+=FIR_BUFFER_SIZE;
          q+=FIR_BUFFER_SIZE;
        }
      }

      b=bo[channel]=16;
    }

    if(b & 1) {
      dct64_486(buf[1]+b,buf[0]+b,bandPtr);
    } else {
      dct64_486(buf[0]+b,buf[1]+b,bandPtr);
    }
    bandPtr+=32;
  }
  bo[channel]=b;


  b=bo_start;
  for(block=0;block<nb_blocks;block++) {
    b++;
    if (b >= FIR_BUFFER_SIZE) b=16;
    if(b & 1) {
      b0 = buf[0] + b - (16 -1);
    } else {
      b0 = buf[1] + b - (16 -1);
    }

 { int sum; sum=(-7)*b0[0]+(53)*b0[1]+(-114)*b0[2]+(509)*b0[3]+ (-1288)*b0[4]+(1643)*b0[5]+(-9372)*b0[6]+(18759)*b0[7]+ (9372)*b0[8]+(1643)*b0[9]+(1288)*b0[10]+(509)*b0[11]+ (114)*b0[12]+(53)*b0[13]+(7)*b0[14]+(0)*b0[15]; sum=(sum+(1 << 13))>>14; if (sum<-32768) sum=-32768; else if (sum>32767) sum=32767; samples[2*(0)]=sum; b0+=FIR_BUFFER_SIZE;};
 { int sum1,sum2,v; v=b0[0]; sum1=(-6)*v; sum2=(0)*v; v=b0[1]; sum1+=(52)*v; sum2+=(-7)*v; v=b0[2]; sum1+=(-100)*v; sum2+=(54)*v; v=b0[3]; sum1+=(515)*v; sum2+=(-129)*v; v=b0[4]; sum1+=(-1197)*v; sum2+=(500)*v; v=b0[5]; sum1+=(1783)*v; sum2+=(-1379)*v; v=b0[6]; sum1+=(-8910)*v; sum2+=(1489)*v; v=b0[7]; sum1+=(18748)*v; sum2+=(-9834)*v; v=b0[8]; sum1+=(9834)*v; sum2+=(18748)*v; v=b0[9]; sum1+=(1489)*v; sum2+=(8910)*v; v=b0[10]; sum1+=(1379)*v; sum2+=(1783)*v; v=b0[11]; sum1+=(500)*v; sum2+=(1197)*v; v=b0[12]; sum1+=(129)*v; sum2+=(515)*v; v=b0[13]; sum1+=(54)*v; sum2+=(100)*v; v=b0[14]; sum1+=(7)*v; sum2+=(52)*v; v=b0[15]; sum1+=(0)*v; sum2+=(6)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(1)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(31)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-6)*v; sum2=(0)*v; v=b0[1]; sum1+=(50)*v; sum2+=(-8)*v; v=b0[2]; sum1+=(-86)*v; sum2+=(55)*v; v=b0[3]; sum1+=(520)*v; sum2+=(-145)*v; v=b0[4]; sum1+=(-1106)*v; sum2+=(488)*v; v=b0[5]; sum1+=(1910)*v; sum2+=(-1469)*v; v=b0[6]; sum1+=(-8447)*v; sum2+=(1322)*v; v=b0[7]; sum1+=(18714)*v; sum2+=(-10294)*v; v=b0[8]; sum1+=(10294)*v; sum2+=(18714)*v; v=b0[9]; sum1+=(1322)*v; sum2+=(8447)*v; v=b0[10]; sum1+=(1469)*v; sum2+=(1910)*v; v=b0[11]; sum1+=(488)*v; sum2+=(1106)*v; v=b0[12]; sum1+=(145)*v; sum2+=(520)*v; v=b0[13]; sum1+=(55)*v; sum2+=(86)*v; v=b0[14]; sum1+=(8)*v; sum2+=(50)*v; v=b0[15]; sum1+=(0)*v; sum2+=(6)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(2)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(30)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-5)*v; sum2=(0)*v; v=b0[1]; sum1+=(49)*v; sum2+=(-9)*v; v=b0[2]; sum1+=(-73)*v; sum2+=(56)*v; v=b0[3]; sum1+=(521)*v; sum2+=(-161)*v; v=b0[4]; sum1+=(-1015)*v; sum2+=(473)*v; v=b0[5]; sum1+=(2023)*v; sum2+=(-1559)*v; v=b0[6]; sum1+=(-7986)*v; sum2+=(1140)*v; v=b0[7]; sum1+=(18657)*v; sum2+=(-10751)*v; v=b0[8]; sum1+=(10751)*v; sum2+=(18657)*v; v=b0[9]; sum1+=(1140)*v; sum2+=(7986)*v; v=b0[10]; sum1+=(1559)*v; sum2+=(2023)*v; v=b0[11]; sum1+=(473)*v; sum2+=(1015)*v; v=b0[12]; sum1+=(161)*v; sum2+=(521)*v; v=b0[13]; sum1+=(56)*v; sum2+=(73)*v; v=b0[14]; sum1+=(9)*v; sum2+=(49)*v; v=b0[15]; sum1+=(0)*v; sum2+=(5)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(3)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(29)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

    samples+=64;
  }
  samples-=64*nb_blocks;



  b=bo_start;
  for(block=0;block<nb_blocks;block++) {
    b++;
    if (b >= FIR_BUFFER_SIZE) b=16;
    if(b & 1) {
      b0 = buf[0] + b - (16 -1) + 4*FIR_BUFFER_SIZE;
    } else {
      b0 = buf[1] + b - (16 -1) + 4*FIR_BUFFER_SIZE;
    }

 { int sum1,sum2,v; v=b0[0]; sum1=(-4)*v; sum2=(0)*v; v=b0[1]; sum1+=(47)*v; sum2+=(-10)*v; v=b0[2]; sum1+=(-61)*v; sum2+=(56)*v; v=b0[3]; sum1+=(521)*v; sum2+=(-177)*v; v=b0[4]; sum1+=(-926)*v; sum2+=(455)*v; v=b0[5]; sum1+=(2123)*v; sum2+=(-1647)*v; v=b0[6]; sum1+=(-7528)*v; sum2+=(944)*v; v=b0[7]; sum1+=(18578)*v; sum2+=(-11205)*v; v=b0[8]; sum1+=(11205)*v; sum2+=(18578)*v; v=b0[9]; sum1+=(944)*v; sum2+=(7528)*v; v=b0[10]; sum1+=(1647)*v; sum2+=(2123)*v; v=b0[11]; sum1+=(455)*v; sum2+=(926)*v; v=b0[12]; sum1+=(177)*v; sum2+=(521)*v; v=b0[13]; sum1+=(56)*v; sum2+=(61)*v; v=b0[14]; sum1+=(10)*v; sum2+=(47)*v; v=b0[15]; sum1+=(0)*v; sum2+=(4)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(4)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(28)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-4)*v; sum2=(0)*v; v=b0[1]; sum1+=(45)*v; sum2+=(-11)*v; v=b0[2]; sum1+=(-49)*v; sum2+=(57)*v; v=b0[3]; sum1+=(518)*v; sum2+=(-194)*v; v=b0[4]; sum1+=(-837)*v; sum2+=(434)*v; v=b0[5]; sum1+=(2210)*v; sum2+=(-1733)*v; v=b0[6]; sum1+=(-7072)*v; sum2+=(733)*v; v=b0[7]; sum1+=(18477)*v; sum2+=(-11654)*v; v=b0[8]; sum1+=(11654)*v; sum2+=(18477)*v; v=b0[9]; sum1+=(733)*v; sum2+=(7072)*v; v=b0[10]; sum1+=(1733)*v; sum2+=(2210)*v; v=b0[11]; sum1+=(434)*v; sum2+=(837)*v; v=b0[12]; sum1+=(194)*v; sum2+=(518)*v; v=b0[13]; sum1+=(57)*v; sum2+=(49)*v; v=b0[14]; sum1+=(11)*v; sum2+=(45)*v; v=b0[15]; sum1+=(0)*v; sum2+=(4)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(5)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(27)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-4)*v; sum2=(0)*v; v=b0[1]; sum1+=(44)*v; sum2+=(-12)*v; v=b0[2]; sum1+=(-38)*v; sum2+=(57)*v; v=b0[3]; sum1+=(514)*v; sum2+=(-212)*v; v=b0[4]; sum1+=(-751)*v; sum2+=(411)*v; v=b0[5]; sum1+=(2284)*v; sum2+=(-1817)*v; v=b0[6]; sum1+=(-6620)*v; sum2+=(509)*v; v=b0[7]; sum1+=(18353)*v; sum2+=(-12097)*v; v=b0[8]; sum1+=(12097)*v; sum2+=(18353)*v; v=b0[9]; sum1+=(509)*v; sum2+=(6620)*v; v=b0[10]; sum1+=(1817)*v; sum2+=(2284)*v; v=b0[11]; sum1+=(411)*v; sum2+=(751)*v; v=b0[12]; sum1+=(212)*v; sum2+=(514)*v; v=b0[13]; sum1+=(57)*v; sum2+=(38)*v; v=b0[14]; sum1+=(12)*v; sum2+=(44)*v; v=b0[15]; sum1+=(0)*v; sum2+=(4)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(6)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(26)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-3)*v; sum2=(0)*v; v=b0[1]; sum1+=(42)*v; sum2+=(-13)*v; v=b0[2]; sum1+=(-27)*v; sum2+=(56)*v; v=b0[3]; sum1+=(508)*v; sum2+=(-229)*v; v=b0[4]; sum1+=(-665)*v; sum2+=(383)*v; v=b0[5]; sum1+=(2347)*v; sum2+=(-1899)*v; v=b0[6]; sum1+=(-6173)*v; sum2+=(270)*v; v=b0[7]; sum1+=(18208)*v; sum2+=(-12534)*v; v=b0[8]; sum1+=(12534)*v; sum2+=(18208)*v; v=b0[9]; sum1+=(270)*v; sum2+=(6173)*v; v=b0[10]; sum1+=(1899)*v; sum2+=(2347)*v; v=b0[11]; sum1+=(383)*v; sum2+=(665)*v; v=b0[12]; sum1+=(229)*v; sum2+=(508)*v; v=b0[13]; sum1+=(56)*v; sum2+=(27)*v; v=b0[14]; sum1+=(13)*v; sum2+=(42)*v; v=b0[15]; sum1+=(0)*v; sum2+=(3)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(7)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(25)*2]=sum2; b0+=FIR_BUFFER_SIZE;};


    samples+=64;
  }
  samples-=64*nb_blocks;



  b=bo_start;
  for(block=0;block<nb_blocks;block++) {
    b++;
    if (b >= FIR_BUFFER_SIZE) b=16;
    if(b & 1) {
      b0 = buf[0] + b - (16 -1) + 8*FIR_BUFFER_SIZE;
    } else {
      b0 = buf[1] + b - (16 -1) + 8*FIR_BUFFER_SIZE;
    }

 { int sum1,sum2,v; v=b0[0]; sum1=(-3)*v; sum2=(0)*v; v=b0[1]; sum1+=(40)*v; sum2+=(-14)*v; v=b0[2]; sum1+=(-18)*v; sum2+=(56)*v; v=b0[3]; sum1+=(500)*v; sum2+=(-247)*v; v=b0[4]; sum1+=(-582)*v; sum2+=(353)*v; v=b0[5]; sum1+=(2398)*v; sum2+=(-1977)*v; v=b0[6]; sum1+=(-5732)*v; sum2+=(17)*v; v=b0[7]; sum1+=(18042)*v; sum2+=(-12963)*v; v=b0[8]; sum1+=(12963)*v; sum2+=(18042)*v; v=b0[9]; sum1+=(17)*v; sum2+=(5732)*v; v=b0[10]; sum1+=(1977)*v; sum2+=(2398)*v; v=b0[11]; sum1+=(353)*v; sum2+=(582)*v; v=b0[12]; sum1+=(247)*v; sum2+=(500)*v; v=b0[13]; sum1+=(56)*v; sum2+=(18)*v; v=b0[14]; sum1+=(14)*v; sum2+=(40)*v; v=b0[15]; sum1+=(0)*v; sum2+=(3)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(8)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(24)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-2)*v; sum2=(0)*v; v=b0[1]; sum1+=(38)*v; sum2+=(-15)*v; v=b0[2]; sum1+=(-9)*v; sum2+=(55)*v; v=b0[3]; sum1+=(490)*v; sum2+=(-266)*v; v=b0[4]; sum1+=(-501)*v; sum2+=(320)*v; v=b0[5]; sum1+=(2437)*v; sum2+=(-2052)*v; v=b0[6]; sum1+=(-5297)*v; sum2+=(-249)*v; v=b0[7]; sum1+=(17855)*v; sum2+=(-13383)*v; v=b0[8]; sum1+=(13383)*v; sum2+=(17855)*v; v=b0[9]; sum1+=(-249)*v; sum2+=(5297)*v; v=b0[10]; sum1+=(2052)*v; sum2+=(2437)*v; v=b0[11]; sum1+=(320)*v; sum2+=(501)*v; v=b0[12]; sum1+=(266)*v; sum2+=(490)*v; v=b0[13]; sum1+=(55)*v; sum2+=(9)*v; v=b0[14]; sum1+=(15)*v; sum2+=(38)*v; v=b0[15]; sum1+=(0)*v; sum2+=(2)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(9)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(23)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-2)*v; sum2=(0)*v; v=b0[1]; sum1+=(36)*v; sum2+=(-17)*v; v=b0[2]; sum1+=(0)*v; sum2+=(53)*v; v=b0[3]; sum1+=(479)*v; sum2+=(-284)*v; v=b0[4]; sum1+=(-423)*v; sum2+=(282)*v; v=b0[5]; sum1+=(2465)*v; sum2+=(-2122)*v; v=b0[6]; sum1+=(-4869)*v; sum2+=(-530)*v; v=b0[7]; sum1+=(17647)*v; sum2+=(-13794)*v; v=b0[8]; sum1+=(13794)*v; sum2+=(17647)*v; v=b0[9]; sum1+=(-530)*v; sum2+=(4869)*v; v=b0[10]; sum1+=(2122)*v; sum2+=(2465)*v; v=b0[11]; sum1+=(282)*v; sum2+=(423)*v; v=b0[12]; sum1+=(284)*v; sum2+=(479)*v; v=b0[13]; sum1+=(53)*v; sum2+=(0)*v; v=b0[14]; sum1+=(17)*v; sum2+=(36)*v; v=b0[15]; sum1+=(0)*v; sum2+=(2)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(10)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(22)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-2)*v; sum2=(0)*v; v=b0[1]; sum1+=(34)*v; sum2+=(-18)*v; v=b0[2]; sum1+=(7)*v; sum2+=(52)*v; v=b0[3]; sum1+=(467)*v; sum2+=(-302)*v; v=b0[4]; sum1+=(-347)*v; sum2+=(242)*v; v=b0[5]; sum1+=(2483)*v; sum2+=(-2188)*v; v=b0[6]; sum1+=(-4449)*v; sum2+=(-825)*v; v=b0[7]; sum1+=(17419)*v; sum2+=(-14194)*v; v=b0[8]; sum1+=(14194)*v; sum2+=(17419)*v; v=b0[9]; sum1+=(-825)*v; sum2+=(4449)*v; v=b0[10]; sum1+=(2188)*v; sum2+=(2483)*v; v=b0[11]; sum1+=(242)*v; sum2+=(347)*v; v=b0[12]; sum1+=(302)*v; sum2+=(467)*v; v=b0[13]; sum1+=(52)*v; sum2+=(-7)*v; v=b0[14]; sum1+=(18)*v; sum2+=(34)*v; v=b0[15]; sum1+=(0)*v; sum2+=(2)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(11)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(21)*2]=sum2; b0+=FIR_BUFFER_SIZE;};


    samples+=64;
  }
  samples-=64*nb_blocks;



  b=bo_start;
  for(block=0;block<nb_blocks;block++) {
    b++;
    if (b >= FIR_BUFFER_SIZE) b=16;
    if(b & 1) {
      b0 = buf[0] + b - (16 -1) + 12*FIR_BUFFER_SIZE;
    } else {
      b0 = buf[1] + b - (16 -1) + 12*FIR_BUFFER_SIZE;
    }

 { int sum1,sum2,v; v=b0[0]; sum1=(-2)*v; sum2=(0)*v; v=b0[1]; sum1+=(33)*v; sum2+=(-19)*v; v=b0[2]; sum1+=(14)*v; sum2+=(50)*v; v=b0[3]; sum1+=(454)*v; sum2+=(-320)*v; v=b0[4]; sum1+=(-273)*v; sum2+=(198)*v; v=b0[5]; sum1+=(2491)*v; sum2+=(-2249)*v; v=b0[6]; sum1+=(-4038)*v; sum2+=(-1133)*v; v=b0[7]; sum1+=(17173)*v; sum2+=(-14583)*v; v=b0[8]; sum1+=(14583)*v; sum2+=(17173)*v; v=b0[9]; sum1+=(-1133)*v; sum2+=(4038)*v; v=b0[10]; sum1+=(2249)*v; sum2+=(2491)*v; v=b0[11]; sum1+=(198)*v; sum2+=(273)*v; v=b0[12]; sum1+=(320)*v; sum2+=(454)*v; v=b0[13]; sum1+=(50)*v; sum2+=(-14)*v; v=b0[14]; sum1+=(19)*v; sum2+=(33)*v; v=b0[15]; sum1+=(0)*v; sum2+=(2)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(12)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(20)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-1)*v; sum2=(-1)*v; v=b0[1]; sum1+=(31)*v; sum2+=(-21)*v; v=b0[2]; sum1+=(20)*v; sum2+=(47)*v; v=b0[3]; sum1+=(439)*v; sum2+=(-339)*v; v=b0[4]; sum1+=(-203)*v; sum2+=(151)*v; v=b0[5]; sum1+=(2489)*v; sum2+=(-2304)*v; v=b0[6]; sum1+=(-3637)*v; sum2+=(-1454)*v; v=b0[7]; sum1+=(16907)*v; sum2+=(-14959)*v; v=b0[8]; sum1+=(14959)*v; sum2+=(16907)*v; v=b0[9]; sum1+=(-1454)*v; sum2+=(3637)*v; v=b0[10]; sum1+=(2304)*v; sum2+=(2489)*v; v=b0[11]; sum1+=(151)*v; sum2+=(203)*v; v=b0[12]; sum1+=(339)*v; sum2+=(439)*v; v=b0[13]; sum1+=(47)*v; sum2+=(-20)*v; v=b0[14]; sum1+=(21)*v; sum2+=(31)*v; v=b0[15]; sum1+=(-1)*v; sum2+=(1)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(13)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(19)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-1)*v; sum2=(-1)*v; v=b0[1]; sum1+=(29)*v; sum2+=(-22)*v; v=b0[2]; sum1+=(26)*v; sum2+=(44)*v; v=b0[3]; sum1+=(424)*v; sum2+=(-357)*v; v=b0[4]; sum1+=(-136)*v; sum2+=(100)*v; v=b0[5]; sum1+=(2479)*v; sum2+=(-2354)*v; v=b0[6]; sum1+=(-3245)*v; sum2+=(-1788)*v; v=b0[7]; sum1+=(16623)*v; sum2+=(-15322)*v; v=b0[8]; sum1+=(15322)*v; sum2+=(16623)*v; v=b0[9]; sum1+=(-1788)*v; sum2+=(3245)*v; v=b0[10]; sum1+=(2354)*v; sum2+=(2479)*v; v=b0[11]; sum1+=(100)*v; sum2+=(136)*v; v=b0[12]; sum1+=(357)*v; sum2+=(424)*v; v=b0[13]; sum1+=(44)*v; sum2+=(-26)*v; v=b0[14]; sum1+=(22)*v; sum2+=(29)*v; v=b0[15]; sum1+=(-1)*v; sum2+=(1)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(14)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(18)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum1,sum2,v; v=b0[0]; sum1=(-1)*v; sum2=(-1)*v; v=b0[1]; sum1+=(27)*v; sum2+=(-24)*v; v=b0[2]; sum1+=(31)*v; sum2+=(40)*v; v=b0[3]; sum1+=(408)*v; sum2+=(-374)*v; v=b0[4]; sum1+=(-72)*v; sum2+=(46)*v; v=b0[5]; sum1+=(2459)*v; sum2+=(-2396)*v; v=b0[6]; sum1+=(-2863)*v; sum2+=(-2135)*v; v=b0[7]; sum1+=(16322)*v; sum2+=(-15671)*v; v=b0[8]; sum1+=(15671)*v; sum2+=(16322)*v; v=b0[9]; sum1+=(-2135)*v; sum2+=(2863)*v; v=b0[10]; sum1+=(2396)*v; sum2+=(2459)*v; v=b0[11]; sum1+=(46)*v; sum2+=(72)*v; v=b0[12]; sum1+=(374)*v; sum2+=(408)*v; v=b0[13]; sum1+=(40)*v; sum2+=(-31)*v; v=b0[14]; sum1+=(24)*v; sum2+=(27)*v; v=b0[15]; sum1+=(-1)*v; sum2+=(1)*v; sum1=(sum1+(1<<13))>>14; sum2=(sum2+(1<<13))>>14; if (sum1<-32768) sum1=-32768; else if (sum1>32767) sum1=32767; samples[(15)*2]=sum1; if (sum2<-32768) sum2=-32768; else if (sum2>32767) sum2=32767; samples[(17)*2]=sum2; b0+=FIR_BUFFER_SIZE;};

 { int sum; sum=(-1)*b0[0]+(0)*b0[1]+(36)*b0[2]+(0)*b0[3]+ (-11)*b0[4]+(0)*b0[5]+(-2493)*b0[6]+(0)*b0[7]+ (16004)*b0[8]+(0)*b0[9]+(2431)*b0[10]+(0)*b0[11]+ (391)*b0[12]+(0)*b0[13]+(26)*b0[14]+(0)*b0[15]; sum=(sum+(1 << 13))>>14; if (sum<-32768) sum=-32768; else if (sum>32767) sum=32767; samples[2*(16)]=sum; b0+=FIR_BUFFER_SIZE;};

    samples+=64;
  }

  return clip;
}
