
#include "mpg123.h"
#include "mpglib.h"

#define BUFFER_MAX (16384)
#define BUFFER_MAX2 (BUFFER_MAX>>1)
/*
16384, 8129
*/
char buf[BUFFER_MAX];
struct mpstr mp;

void print_header(struct frame *fr)
{
	static char *modes[4] = { "Stereo", "Joint-Stereo", "Dual-Channel", "Single-Channel" };
	static char *layers[4] = { "Unknown" , "I", "II", "III" };

	fprintf(stderr,"MPEG %s, Layer: %s, Freq: %ld, mode: %s, modext: %d, BPF : %d\n", 
		fr->mpeg25 ? "2.5" : (fr->lsf ? "2.0" : "1.0"),
		layers[fr->lay],freqs[fr->sampling_frequency],
		modes[fr->mode],fr->mode_ext,fr->framesize+4);
	fprintf(stderr,"Channels: %d, copyright: %s, original: %s, CRC: %s, emphasis: %d.\n",
		fr->stereo,fr->copyright?"Yes":"No",
		fr->original?"Yes":"No",fr->error_protection?"Yes":"No",
		fr->emphasis);
/*	fprintf(stderr,"Bitrate: %d Kbits/s, Extension value: %d\n",
		tabsel_123[fr->lsf][fr->lay-1][fr->bitrate_index],fr->extension);
*/}
/*
void print_header_compact(struct frame *fr)
{
	static char *modes[4] = { "stereo", "joint-stereo", "dual-channel", "mono" };
	static char *layers[4] = { "Unknown" , "I", "II", "III" };
 
	fprintf(stderr,"MPEG %s layer %s, %d kbit/s, %ld Hz %s\n",
		fr->mpeg25 ? "2.5" : (fr->lsf ? "2.0" : "1.0"),
		layers[fr->lay],
		tabsel_123[fr->lsf][fr->lay-1][fr->bitrate_index],
		freqs[fr->sampling_frequency], modes[fr->mode]);
}
*/

void main(void)
{
	int size;
	char out[BUFFER_MAX2];
	int len,ret;
	
	InitMP3(&mp);
	while(1) {
		len = read(0,buf,BUFFER_MAX);
		if(len <= 0)
			break;
		ret = decodeMP3(&mp,buf,len,out,BUFFER_MAX2,&size);
		while(ret == MP3_OK)
		{
			write(1,out,size);
			ret = decodeMP3(&mp,NULL,0,out,BUFFER_MAX2,&size);
		}
	}

}

